<?php
/**
 * 
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 * 
 */

require_once("../require.php");

class LC_Page {
	var $arrSession;
	var $tpl_mode;
	var $tpl_login_email;
	function LC_Page() {
		$this->tpl_mainpage = 'shopping/index.tpl';
		global $arrPref;
		$this->arrPref = $arrPref;
		global $arrSex;
		$this->arrSex = $arrSex;
		global $arrJob;
		$this->arrJob = $arrJob;
		$this->tpl_onload = 'fnCheckInputDeliv();';
		
		/*
		 session_startno-cacheإå뤳Ȥ
		 ץܥѻͭڤɽ롣
		 private-no-expire:饤ȤΥåĤ롣
		*/
		session_cache_limiter('private-no-expire');				
	}
}

$conn = new SC_DBConn();
$objPage = new LC_Page();
$objView = new SC_MobileView();
$objSiteSess = new SC_SiteSession();
$objCartSess = new SC_CartSession();
$objCustomer = new SC_Customer();
$objCookie = new SC_Cookie();
$objFormParam = new SC_FormParam();			// ե
lfInitParam();								// ѥ᡼ν
$objFormParam->setParam($_POST);			// POSTͤμ

// 桼ˡIDμȹ֤å
$uniqid = sfCheckNormalAccess($objSiteSess, $objCartSess);

$objPage->tpl_uniqid = $uniqid;

// å
if($objCustomer->isLoginSuccess()) {
	// Ǥ˥󤵤ƤϡϤ̤ž
	header("Location: " . gfAddSessionId(sfGetCurrentUri() . "/deliv.php"));
	exit;
}

// üIDפ¸ߤ뤫ɤå롣
$objPage->tpl_valid_phone_id = $objCustomer->checkMobilePhoneId();

switch($_POST['mode']) {
case 'nonmember_confirm':
	$objPage = lfSetNonMember($objPage);
	// breakʤ
case 'confirm':
	// ͤѴ
	$objFormParam->convParam();
	$objFormParam->toLower('order_mail');
	$objFormParam->toLower('order_mail_check');
	
	$objPage->arrErr = lfCheckError();

	// ϥ顼ʤ
	if(count($objPage->arrErr) == 0) {
		// DBؤΥǡϿ
		lfRegistData($uniqid);
		// Ͽ줿ȤϿƤ
		$objSiteSess->setRegistFlag();
		// ʧˡڡذư
		header("Location: " . gfAddSessionId(MOBILE_URL_SHOP_PAYMENT));
		exit;		
	}
	
	break;
// Υڡ
case 'return':
	// ǧڡذư
	header("Location: " . gfAddSessionId(MOBILE_URL_CART_TOP));
	exit;
	break;
case 'nonmember':
	$objPage = lfSetNonMember($objPage);
	// breakʤ
default:
	if($_GET['from'] == 'nonmember') {
		$objPage = lfSetNonMember($objPage);
	}
	// 桼ˡIDμ
	$uniqid = $objSiteSess->getUniqId();
	$objQuery = new SC_Query();
	$where = "order_temp_id = ?";
	$arrRet = $objQuery->select("*", "dtb_order_temp", $where, array($uniqid));
	// DBͤμ
	$objFormParam->setParam($arrRet[0]);
	$objFormParam->setValue('order_email_check', $arrRet[0]['order_email']);
	$objFormParam->setDBDate($arrRet[0]['order_birth']);
	break;
}

// åȽ
$objPage->tpl_login_email = $objCookie->getCookie('login_email');
if($objPage->tpl_login_email != "") {
	$objPage->tpl_login_memory = "1";
}

// դμ
$objDate = new SC_Date(START_BIRTH_YEAR);
$objPage->arrYear = $objDate->getYear('', 1950);	//եץ
$objPage->arrMonth = $objDate->getMonth();
$objPage->arrDay = $objDate->getDay();

if($objPage->year == '') {
	$objPage->year = '----';
}

// ͤμ
$objPage->arrForm = $objFormParam->getFormParamList();

if($objPage->arrForm['year']['value'] == ""){
	$objPage->arrForm['year']['value'] = '----';	
}

$objView->assignobj($objPage);
$objView->display(SITE_FRAME);
//--------------------------------------------------------------------------------------------------------------------------
/* ϥڡΥå */
function lfSetNonMember($objPage) {
	$objPage->tpl_mainpage = 'shopping/nonmember_input.tpl';
	$objPage->tpl_css = array();
	$objPage->tpl_css[] = '/css/layout/login/nonmember.css';
	return $objPage;
}

/* ѥ᡼ν */
function lfInitParam() {
	global $objFormParam;
	$objFormParam->addParam("̾", "order_name01", STEXT_LEN, "KVa", array("EXIST_CHECK", "SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("̾̾", "order_name02", STEXT_LEN, "KVa", array("EXIST_CHECK", "SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("եꥬʡʥ", "order_kana01", STEXT_LEN, "KVCa", array("EXIST_CHECK", "SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("եꥬʡʥᥤ", "order_kana02", STEXT_LEN, "KVCa", array("EXIST_CHECK", "SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("͹ֹ1", "order_zip01", ZIP01_LEN, "n", array("EXIST_CHECK", "NUM_CHECK", "NUM_COUNT_CHECK"));
	$objFormParam->addParam("͹ֹ2", "order_zip02", ZIP02_LEN, "n", array("EXIST_CHECK", "NUM_CHECK", "NUM_COUNT_CHECK"));
	$objFormParam->addParam("ƻܸ", "order_pref", INT_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("1", "order_addr01", STEXT_LEN, "KVa", array("EXIST_CHECK", "SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("2", "order_addr02", STEXT_LEN, "KVa", array("EXIST_CHECK", "SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("ֹ1", "order_tel01", TEL_ITEM_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("ֹ2", "order_tel02", TEL_ITEM_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("ֹ3", "order_tel03", TEL_ITEM_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("FAXֹ1", "order_fax01", TEL_ITEM_LEN, "n", array("MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("FAXֹ2", "order_fax02", TEL_ITEM_LEN, "n", array("MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("FAXֹ3", "order_fax03", TEL_ITEM_LEN, "n", array("MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("᡼륢ɥ쥹", "order_email", STEXT_LEN, "KVa", array("EXIST_CHECK", "SPTAB_CHECK", "NO_SPTAB", "MAX_LENGTH_CHECK", "EMAIL_CHECK", "EMAIL_CHAR_CHECK"));
	$objFormParam->addParam("᡼륢ɥ쥹ʳǧ", "order_email_check", STEXT_LEN, "KVa", array("EXIST_CHECK", "SPTAB_CHECK", "NO_SPTAB", "MAX_LENGTH_CHECK", "EMAIL_CHECK", "EMAIL_CHAR_CHECK"), "", false);
	$objFormParam->addParam("ǯ", "year", INT_LEN, "n", array("MAX_LENGTH_CHECK"), "", false);
	$objFormParam->addParam("", "month", INT_LEN, "n", array("MAX_LENGTH_CHECK"), "", false);
	$objFormParam->addParam("", "day", INT_LEN, "n", array("MAX_LENGTH_CHECK"), "", false);
	$objFormParam->addParam("", "order_sex", INT_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("", "order_job", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("̤ΤϤ", "deliv_check", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("̾", "deliv_name01", STEXT_LEN, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("̾̾", "deliv_name02", STEXT_LEN, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("եꥬʡʥ", "deliv_kana01", STEXT_LEN, "KVCa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("եꥬʡʥᥤ", "deliv_kana02", STEXT_LEN, "KVCa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("͹ֹ1", "deliv_zip01", ZIP01_LEN, "n", array("NUM_CHECK", "NUM_COUNT_CHECK"));
	$objFormParam->addParam("͹ֹ2", "deliv_zip02", ZIP02_LEN, "n", array("NUM_CHECK", "NUM_COUNT_CHECK"));
	$objFormParam->addParam("ƻܸ", "deliv_pref", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("1", "deliv_addr01", STEXT_LEN, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("2", "deliv_addr02", STEXT_LEN, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("ֹ1", "deliv_tel01", TEL_ITEM_LEN, "n", array("MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("ֹ2", "deliv_tel02", TEL_ITEM_LEN, "n", array("MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("ֹ3", "deliv_tel03", TEL_ITEM_LEN, "n", array("MAX_LENGTH_CHECK" ,"NUM_CHECK"));
	$objFormParam->addParam("᡼ޥ", "mail_flag", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK"), 1);
}

/* DBإǡϿ */
function lfRegistData($uniqid) {
	global $objFormParam;
	$arrRet = $objFormParam->getHashArray();
	$sqlval = $objFormParam->getDbArray();
	// Ͽǡκ
	$sqlval['order_temp_id'] = $uniqid;
	$sqlval['order_birth'] = sfGetTimestamp($arrRet['year'], $arrRet['month'], $arrRet['day']);
	$sqlval['update_date'] = 'Now()';
	$sqlval['customer_id'] = '0';
	
	// ¸ǡΥå
	$objQuery = new SC_Query();
	$where = "order_temp_id = ?";
	$cnt = $objQuery->count("dtb_order_temp", $where, array($uniqid));
	// ¸ǡʤ
	if ($cnt == 0) {
		$sqlval['create_date'] = 'Now()';
		$objQuery->insert("dtb_order_temp", $sqlval);
	} else {
		$objQuery->update("dtb_order_temp", $sqlval, $where, array($uniqid));
	}
}

/* ƤΥå */
function lfCheckError() {
	global $objFormParam;
	// ϥǡϤ
	$arrRet =  $objFormParam->getHashArray();
	$objErr = new SC_CheckError($arrRet);
	$objErr->arrErr = $objFormParam->checkError();
		
	// ̤ΤϤå
	if($_POST['deliv_check'] == "1") { 
		$objErr->doFunc(array("̾", "deliv_name01"), array("EXIST_CHECK"));
		$objErr->doFunc(array("̾̾", "deliv_name02"), array("EXIST_CHECK"));
		$objErr->doFunc(array("եꥬʡʥ", "deliv_kana01"), array("EXIST_CHECK"));
		$objErr->doFunc(array("եꥬʡʥᥤ", "deliv_kana02"), array("EXIST_CHECK"));
		$objErr->doFunc(array("͹ֹ1", "deliv_zip01"), array("EXIST_CHECK"));
		$objErr->doFunc(array("͹ֹ2", "deliv_zip02"), array("EXIST_CHECK"));
		$objErr->doFunc(array("ƻܸ", "deliv_pref"), array("EXIST_CHECK"));
		$objErr->doFunc(array("1", "deliv_addr01"), array("EXIST_CHECK"));
		$objErr->doFunc(array("2", "deliv_addr02"), array("EXIST_CHECK"));
		$objErr->doFunc(array("ֹ1", "deliv_tel01"), array("EXIST_CHECK"));
		$objErr->doFunc(array("ֹ2", "deliv_tel02"), array("EXIST_CHECK"));
		$objErr->doFunc(array("ֹ3", "deliv_tel03"), array("EXIST_CHECK"));
	}
	
	// ʣܥå
	$objErr->doFunc(array("TEL", "order_tel01", "order_tel02", "order_tel03", TEL_ITEM_LEN), array("TEL_CHECK"));
	$objErr->doFunc(array("FAX", "order_fax01", "order_fax02", "order_fax03", TEL_ITEM_LEN), array("TEL_CHECK"));
	$objErr->doFunc(array("͹ֹ", "order_zip01", "order_zip02"), array("ALL_EXIST_CHECK"));
	$objErr->doFunc(array("TEL", "deliv_tel01", "deliv_tel02", "deliv_tel03", TEL_ITEM_LEN), array("TEL_CHECK"));
	$objErr->doFunc(array("FAX", "deliv_fax01", "deliv_fax02", "deliv_fax03", TEL_ITEM_LEN), array("TEL_CHECK"));
	$objErr->doFunc(array("͹ֹ", "deliv_zip01", "deliv_zip02"), array("ALL_EXIST_CHECK"));
	$objErr->doFunc(array("ǯ", "year", "month", "day"), array("CHECK_DATE"));
	$objErr->doFunc(array("᡼륢ɥ쥹", "᡼륢ɥ쥹ʳǧ", "order_email", "order_email_check"), array("EQUAL_CHECK"));
	
	// Ǥ˥ޥơ֥˲Ȥƥ᡼륢ɥ쥹ϿƤ
	if(sfCheckCustomerMailMaga($arrRet['order_email'])) {
		$objErr->arrErr['order_email'] = "Υ᡼륢ɥ쥹ϤǤϿƤޤ<br>";
	}
		
	return $objErr->arrErr;
}
?>
